#include <SPI.h>
#include <SD.h>

#include <OneWire.h>
#include <DallasTemperature.h>

#define ONE_WIRE_BUS 2
const int chipSelect = 4;

unsigned long previousMillis = 0;
const long interval = 1000;

OneWire oneWire(ONE_WIRE_BUS);
DallasTemperature sensors(&oneWire);


void setup() {
  
  Serial.begin(9600);
  
  sensors.begin();

  if (!SD.begin(chipSelect)) {
    Serial.println("Card failed, or not present");
    while (1);
  }
  Serial.println("card initialized.");
}

void loop() {

  

  unsigned long currentMillis = millis();

  if (currentMillis - previousMillis >= interval){

    previousMillis = currentMillis;

    String dataString = "";

    dataString += previousMillis;
    dataString +="\; ";
    
    sensors.requestTemperatures();
    float tempC = sensors.getTempCByIndex(0);
    dataString += tempC;
    
    File dataFile = SD.open("datalog.csv", FILE_WRITE);

    if (dataFile) {
      dataFile.println(dataString);
      dataFile.close();
   
      Serial.println(dataString);
    }
  
    else {
      Serial.println("error opening datalog.csv");
    }
  }
}
